<?php
/**
* SQLビルダを生成するファクトリクラス
*
* PHP version 5
*
* @package    core
* @author     stk2k <stk2k@sazysoft.com>
* @copyright  2008 stk2k, sazysoft
*/

class charcoal_SQLBuilderFactory
{
	/*
	 * SQLビルダを作成
	 */
	public static function create( $builder_name )
	{
		log_info( "system",  "SQLビルダ[$builder_name]をロードします。", __FILE__, __LINE__ );

		// builderConfigをロード
		$config = charcoal_ConfigLoader::loadConfig( $builder_name, "sql_builder" );

		// クラス名を取得
		$class_name = $config->getString( "class_name" );

		// SQLビルダのインスタンス生成
		$builder = charcoal_ClassUtil::newInstance( $class_name );

		// 生成したインスタンスがIbuilderインタフェースを実装しているか確認
		if ( !($builder instanceof charcoal_ISQLBuilder) ){
			// 実装例外
			throw new charcoal_InterfaceImplementException( $class_name, "charcoal_ISQLBuilder" );
		}

		log_info( "system",  "SQLビルダ[$builder_name]を初期化します。", __FILE__, __LINE__ );

		// SQLビルダを初期化
		$builder->init( $config );

		log_info( "system",  "SQLビルダ[$builder_name]をロードしました。", __FILE__, __LINE__ );

		// ロードしたSQLビルダを返却
		return $builder;
	}
}
